'notes
' BSTR as ASCIIZ PTR' unicode
' unicode string: lengthbyte 2byte chars null termination

' MACRO  pr   = IF comlog THEN COMLogPrint ' diagnostic



MACRO HRESULT   = DWORD
MACRO LPOLESTR  = OLESTR PTR ' For array of unicode strings
MACRO DISPID    = LONG
MACRO MEMBERID  = DISPID
MACRO BOOL      = DWORD
MACRO TYPEKIND  = DWORD ' an enumeration type
MACRO REFIID    = GUID
MACRO LCID      = DWORD
MACRO hkey      = DWORD

'---------------------------------------------------------------------------------------
' Equates
'---------------------------------------------------------------------------------------
%CLSCTX_INPROC_SERVER    = &h01

%LOCALE_NEUTRAL         = 0

'SYSKIND
%SYS_WIN16              = 0
%SYS_WIN32              = %SYS_WIN16 + 1
%SYS_MAC                = %SYS_WIN32 + 1
%SYS_WIN64              = %SYS_MAC + 1


%CLSCTX_INPROC_SERVER   = &h01
%CLSCTX_INPROC_HANDLER  = &h02
%CLSCTX_LOCAL_SERVER    = &h04
%CLSCTX_INPROC_SERVER16     = &h08
%CLSCTX_REMOTE_SERVER   = &h010
%CLSCTX_INPROC_HANDLER16= &h020


%CLSCTX_SERVER          = %CLSCTX_INPROC_SERVER OR %CLSCTX_LOCAL_SERVER
%DISPATCH_METHOD        = 1
%CONNECT_E_ADVISELIMIT  = -2147220990
%CONNECT_E_NOCONNECTION = -2147220991

'---------------------------------------------------------------------------------------
' Types
'---------------------------------------------------------------------------------------


TYPE OLESTR
 i(0) AS WORD PTR 'notional array of unicode string pointers to define LPOLESTR type
END TYPE

TYPE ITypeLibVTbl
  QueryInterface    AS DWORD
  AddRef            AS DWORD
  Release           AS DWORD
  '
  ' TypeLib methods
  '
  GetTypeInfoCount  AS DWORD
  GetTypeInfo       AS DWORD
  GetTypeInfoType   AS DWORD
  GetTypeInfoOfGuid AS DWORD
  GetLibAttr        AS DWORD
  GetTypeComp       AS DWORD
  GetDocumentation  AS DWORD
  IsName            AS DWORD
  FindName          AS DWORD
  ReleaseTLibAttr   AS DWORD
END TYPE

TYPE ITypeLib
  lpVTbl AS ITypeLibVTbl PTR
  count AS DWORD
END TYPE

TYPE ITypeInfoVTbl ' from oaidl.h

  QueryInterface        AS DWORD
  AddRef                AS DWORD
  Release               AS DWORD
  '
  '  /*** ITypeInfo methods ***/
  '
  GetTypeAttr           AS DWORD
  GetTypeComp           AS DWORD
  GetFuncDesc           AS DWORD
  GetVarDesc            AS DWORD
  GetNames              AS DWORD
  GetRefTypeOfImplType  AS DWORD
  GetImplTypeFlags      AS DWORD
  GetIDsOfNames         AS DWORD
  Invoke                AS DWORD
  GetDocumentation      AS DWORD
  GetDllEntry           AS DWORD
  GetRefTypeInfo        AS DWORD
  AddressOfMember       AS DWORD
  CreateInstance        AS DWORD
  GetMops               AS DWORD
  GetContainingTypeLib  AS DWORD
  ReleaseTypeAttr       AS DWORD
  ReleaseFuncDesc       AS DWORD
  ReleaseVarDesc        AS DWORD
END TYPE

TYPE ITypeInfo ' from oaidl.h
  lpVTbl AS ITypeInfoVTbl PTR
  '.....
END TYPE

TYPE DISPPARAMS
  VariantArgs           AS VARIANT PTR
  NamedDispId           AS LONG    PTR
  CountArgs             AS DWORD
  CountNamed            AS DWORD
END TYPE

TYPE EXCEPINFO
  bstrDescription       AS WORD  PTR  'Describes the error intended for the customer.
  bstrHelpFile          AS WORD  PTR  'Contains the fully-qualified drive, path, and file name of a Help file that contains more information about the error.
  bstrSource            AS WORD  PTR  'Indicates the name of the source of the exception. Typically, this is an application name.
  dwHelpContext         AS DWORD PTR  'Indicates the Help context ID of the topic within the Help file.
  pfnDeferredFillIn     AS DWORD PTR  'Represents a pointer to a function that takes an EXCEPINFO structure as an argument and returns an HRESULT value. If deferred fill-in is not desired, this field is set to a null reference (Nothing in Visual Basic).
  pvReserved            AS DWORD PTR  'This field is reserved; it must be set to a null reference (Nothing in Visual Basic).
  scode                 AS DWORD PTR  'A return value describing the error.
  wCode                 AS DWORD PTR  'Represents an error code identifying the error.
  wReserved             AS ASCIIZ  PTR 'This field is reserved; it must be set to 0.
END TYPE

' IClassFactory's VTable
TYPE IClassFactoryVTbl
 classQueryInterface    AS DWORD
 classAddRef            AS DWORD
 classRelease           AS DWORD
 classCreateInstance    AS DWORD
 classLockServer        AS DWORD
END TYPE

'TYPE IClassFactory
' lpVTbl AS IClassFactoryVTbl PTR
'END TYPE

TYPE IClassFactori
 lpVTbl AS IClassFactoryVTbl PTR
END TYPE

TYPE IConnectionPointContainerVTbl
 QueryInterface_Connect AS DWORD
 AddRef_Connect         AS DWORD
 Release_Connect        AS DWORD
 EnumConnectionPoints   AS DWORD
 FindConnectionPoint    AS DWORD
END TYPE

TYPE IConnectionPointContainer
 lpVTbl                 AS IConnectionPointContainerVTbl PTR
END TYPE

TYPE IConnectionPointVTbl
 QueryInterface_Point   AS DWORD
 AddRef_Point           AS DWORD
 Release_Point          AS DWORD
 GetConnectionInterface AS DWORD
 GetConnectionPointContainer AS DWORD
 Advise                 AS DWORD
 Unadvise               AS DWORD
 EnumConnections        AS DWORD
END TYPE

TYPE IConnectionPoint
 lpVTbl                 AS IConnectionPointVTbl PTR
END TYPE

TYPE IFeedBackVTbl
 ' functions for Unknown Interface
 QueryInterface         AS DWORD
 AddRef                 AS DWORD
 Release                AS DWORD
 ' additional functions for Dispatch Interface
 GetTypeInfoCount       AS DWORD
 GetTypeInfo            AS DWORD
 GetIDsOfNames          AS DWORD
 Invoke                 AS DWORD
 ' our client's callback functions
 Callback1              AS DWORD
 Callback2              AS DWORD
 Callback3              AS DWORD
 Callback4              AS DWORD
 Callback5              AS DWORD
 Callback6              AS DWORD
 Callback7              AS DWORD
 Callback8              AS DWORD
END TYPE
%MAX_CALLBACK_FUNCS     = 8

TYPE IFeedBack
 lpVTbl                 AS IFeedBackVTbl PTR
END TYPE

TYPE IObjectVTbl
 ' functions for Unknown Interface
 QueryInterface          AS DWORD
 AddRef                  AS DWORD
 Release                 AS DWORD
 ' additional functions for Dispatch Interface
 GetTypeInfoCount        AS DWORD
 GetTypeInfo             AS DWORD
 GetIDsOfNames           AS DWORD
 Invoke                  AS DWORD
 ' our functions
 SetString               AS DWORD
 GetString               AS DWORD
 NullFun                 AS DWORD
 RequestCallback         AS DWORD
 LoadLibrary_I           AS DWORD
 GetProcAddress_I        AS DWORD
 FreeLibrary_I           AS DWORD
 EnableLibraryCallbacks  AS DWORD
 DisableLibraryCallbacks AS DWORD
 fun                     AS DWORD
END TYPE

TYPE IObject
 lpVTbl                  AS IObjectVTbl PTR
 count                   AS DWORD
 container               AS IConnectionPointContainerVTbl PTR ' subobject
 point                   AS IConnectionPointVTbl PTR ' subobject
 feedback                AS IFeedback PTR
 tex                     AS WORD PTR
END TYPE

'Client side connection management

TYPE IConnector
 CLSID   AS GUID
 IID     AS GUID
 DIID    AS GUID
 cf      AS IClassFactori PTR
 obj     AS IObject PTR
 container AS IConnectionPointContainer PTR
 point   AS IConnectionPoint PTR
 events  AS DWORD
 cookie  AS DWORD
END TYPE
