
FUNCTION DllRegisterServer ALIAS "DllRegisterServer" () EXPORT AS LONG

    ' #INCLUDE "inc\COMserver\guids.inc"

    GLOBAL EXEName            AS ASCIIZ*128: EXEName = "COMforDLL.exe"
    GLOBAL ObjectDescription  AS ASCIIZ*128: ObjectDescription = "COMforDLL COM component"
    GLOBAL FileDlgTitle       AS ASCIIZ*128: FileDlgTitle = "Locate COMforDLL.exe to register it"

    GLOBAL FileDlgExt         AS ASCIIZ*128: FileDlgExt = "EXE files\000*.exe\000\000"
    GLOBAL CLSID_Str          AS ASCIIZ*128: CLSID_Str = "CLSID"
    GLOBAL ClassKeyName       AS ASCIIZ*128: ClassKeyName = "Software\\Classes"
    GLOBAL Server32Name       AS ASCIIZ*128: Server32Name = "LocalServer32" 'instead of InProcServer32 for DLL
    GLOBAL ThreadingModel     AS ASCIIZ*128: ThreadingModel = "ThreadingModel"
    GLOBAL BothStr            AS ASCIIZ*128: BothStr = "both"
    GLOBAL GUID_Format        AS ASCIIZ*128: GUID_Format = "{%08lX-%04X-%04X-%02X%02X-%02X%02X%02X%02X%02X%02X}"
    GLOBAL ObjectDescription  AS ASCIIZ*128: ObjectDescription="Intermediary between DLL and COM client"
    GLOBAL ProgID             AS ASCIIZ*128: ProgID="COMforDLL.Object"
    GLOBAL TypeLibName        AS ASCIIZ*128: TypeLibName="COMforDLL.tlb"

    GLOBAL result       AS LONG
    GLOBAL filename     AS ASCIIZ*%MAX_PATH

    'GLOBAL ofn          AS OPENFILENAME

    GLOBAL rootKey      AS hkey
    GLOBAL hKey1        AS HKEY
    GLOBAL hKey2        AS HKEY
    GLOBAL hkextra      AS HKEY
    GLOBAL GUIDtxt      AS ASCIIZ*39
    GLOBAL disposition  AS DWORD
    GLOBAL sa AS SECURITY_ATTRIBUTES


    ' Pick out where our EXE is located. We need to know its location in
    ' order to register it as a COM component

    filename="C:\Program Files\COMforDLL\COMforDLL.exe"

    ' ZeroMemory( ofn, SIZEOF(OPENFILENAME))

    result=1

'for file dialog
    'ofn.lStructSize = SIZEOF(OPENFILENAME)
    'ofn.lpstrFilter = VARPTR(FileDlgExt)
    'ofn.lpstrFile = VARPTR(filename)
    'ofn.nMaxFile = %MAX_PATH
    'ofn.lpstrTitle = VARPTR(FileDlgTitle)
    'ofn.Flags = %OFN_FILEMUSTEXIST OR %OFN_EXPLORER OR %OFN_PATHMUSTEXIST
    'result = GetOpenFileName(ofn)

' for use with regsvr32 /u  uninstall option
    'IF bInstall=0 THEN FUNCTION=cleanups(): EXIT FUNCTION 'check uninstall okay?

    IF result > 0 THEN
     ' Assume an error
     result = 1

     ' Open "HKEY_LOCAL_MACHINE\Software\Classes"
     IF RegOpenKeyEx( %HKEY_LOCAL_MACHINE, ClassKeyName, 0, %KEY_WRITE, rootKey)=0 THEN
      IF RegCreateKeyEx(rootKey, ProgID, 0, "", %REG_OPTION_NON_VOLATILE, %KEY_WRITE, sa, hKey1, disposition)=0 THEN
       RegSetValueEx(hKey1, "", 0, %REG_SZ, ObjectDescription, LEN(ObjectDescription))
       disposition = RegCreateKeyEx(hKey1, CLSID_Str, 0, "", %REG_OPTION_NON_VOLATILE, %KEY_WRITE, sa, hKey2, disposition)
       IF disposition=0 THEN
        GUIDtxt=GUIDTXT$(CLSID_MyObject)
        disposition = RegSetValueEx( hKey2, "", 0, %REG_SZ, GUIDtxt, LEN(GUIDtxt) + 1)
        RegCloseKey(hKey2)
       END IF
       RegCloseKey(hKey1)

       IF RegOpenKeyEx(rootKey, CLSID_Str, 0, %KEY_ALL_ACCESS, hKey1)=0 THEN
        GUIDtxt= GUIDTXT$( CLSID_MyObject )
        IF RegCreateKeyEx(hKey1, GUIDtxt, 0, "", %REG_OPTION_NON_VOLATILE, %KEY_WRITE, sa, hKey2, disposition)=0 THEN
         RegSetValueEx(hKey2, "", 0, %REG_SZ, ObjectDescription, LEN(ObjectDescription))
         IF RegCreateKeyEx(hKey2, Server32Name, 0, "", %REG_OPTION_NON_VOLATILE, %KEY_WRITE, sa, hkExtra, disposition)=0 THEN
          IF RegSetValueEx(hkExtra, "", 0, %REG_SZ, filename, LEN(filename) + 1)=0 THEN
           IF RegSetValueEx(hkExtra, ThreadingModel, 0, %REG_SZ, BothStr, LEN(BothStr))=0 THEN
           disposition=RegCreateKeyEx(hKey2, "ProgID", 0, "", %REG_OPTION_NON_VOLATILE, %KEY_WRITE, sa, hkExtra, disposition)
           IF disposition=0 THEN
            disposition = RegSetValueEx(hkExtra, "", 0, %REG_SZ, ProgID, LEN(ProgID))
            RegCloseKey(hkExtra)
            IF disposition=0 THEN result = 0
            ' MessageBox(0, "Successfully registered COMforDLL.exe as a COM component.", ObjectDescription, %MB_OK)
           END IF
          END IF
          RegCloseKey(hkExtra)
         END IF
        END IF
        RegCloseKey(hKey2)
       END IF
       RegCloseKey(hKey1)
      END IF
     END IF

     IF result=0 THEN
      LOCAL i        AS LONG:               i=LEN(filename)-1
      LOCAL p        AS BYTE PTR:           p=VARPTR(filename)
      LOCAL pTypeLib AS ITypeLib PTR:       pTypeLib=0
      LOCAL wbuffer  AS ASCIIZ*%MAX_PATH*2: wbuffer=STRING$(%MAX_PATH*2,CHR$(0))
      WHILE i>=0
       IF @p[i]=92 THEN EXIT LOOP ' backslash '\' 92
       DECR i
      WEND
      filename=LEFT$(filename,i+1)+TypeLibName
      MultiByteToWideChar(%CP_ACP, 0, filename, -1, VARPTR(wbuffer), %MAX_PATH)
      result = LoadTypeLib(wbuffer, VARPTR(pTypeLib))
      'MSGBOX "TypeLib Loaded "+STR$(pTypeLib)+" result "+STR$(result)+" vtable ptr "+STR$(@pTypeLib.lpVtbl)
      IF result=0 THEN
       result = RegisterTypeLib(pTypeLib, wbuffer, UCODE$("C:\Program Files\COMforDLL")+MKWRD$(0)) ' null szHelpDir
       ' MSGBOX "TypeLib Registered "+STR$(pTypeLib)
       CALL DWORD @pTypeLib.@lpVtbl.Release USING Release(pTypeLib)
      END IF
     END IF
     IF result=0 THEN
     ' MessageBox(0, "Successfully registered COMforDLL", ObjectDescription, %MB_OK)
     END IF
    END IF

    RegCloseKey(rootKey)
    IF result THEN
     DllUnregisterServer(): FUNCTION = %E_FAIL: EXIT FUNCTION
     'MessageBox(0, "Failed to register COMforDLL.exe as a COM component.", ObjectDescription, %MB_OK OR %MB_ICONEXCLAMATION )
    END IF
   END IF
   FUNCTION=0
END FUNCTION




FUNCTION DllUnregisterServer ALIAS "DllUnregisterServer" () EXPORT AS LONG

 GUIDtxt=GUIDTXT$(CLSID_MyObject)

 ' Open "HKEY_LOCAL_MACHINE\Software\Classes"
 IF RegOpenKeyEx( %HKEY_LOCAL_MACHINE, ClassKeyName, 0, %KEY_WRITE, rootKey )=0 THEN

  IF RegOpenKeyEx(rootKey, ProgID, 0, %KEY_ALL_ACCESS, hKey1)=0 THEN
   RegDeleteKey(hKey1, CLSID_Str)
   RegCloseKey(hKey1)
   RegDeleteKey(rootKey, ProgID)

   IF RegOpenKeyEx( rootKey, CLSID_Str, 0, %KEY_ALL_ACCESS, hKey1 )=0 THEN
    IF RegOpenKeyEx(hKey1, GUIDtxt, 0, %KEY_ALL_ACCESS, hKey2)=0 THEN
     RegDeleteKey( hKey2, Server32Name)
     RegDeleteKey( hKey2, "ProgID")
     RegCloseKey( hKey2 )
     RegDeleteKey( hKey1, GUIDtxt )
     MSGBOX "Register Keys have been deleted"
    END IF
    RegCloseKey(hKey1)
   END IF
  END IF
  RegCloseKey(rootKey)

  UnRegisterTypeLib(CLSID_TypeLib, 1, 0, %LOCALE_NEUTRAL, %SYS_WIN32)
  MessageBox(0, "De-registered COMforDLL.exe as a COM component.", ObjectDescription, %MB_OK OR %MB_ICONEXCLAMATION)
  EXIT FUNCTION
 END IF
 FUNCTION=%E_FAIL
END FUNCTION
