#COMPILE DLL
#DIM ALL
#INCLUDE "win32api.inc"

' this function is used by the host DLL to callback to the client
DECLARE FUNCTION CallToClient (_
    BYVAL which AS DWORD, _
    BYVAL pv AS VARIANT PTR _
    ) AS DWORD


GLOBAL gNumOfTimes      AS DWORD
GLOBAL ClientFeedback   AS DWORD

FUNCTION LIBMAIN( _
 BYVAL hInstance AS DWORD, _
 BYVAL Reason    AS LONG, _
 BYVAL Reserved  AS LONG _
 ) AS LONG

  INCR gNumOfTimes

  SELECT CASE Reason

    CASE %DLL_PROCESS_ATTACH
      'MSGBOX "%DLL_PROCESS_ATTACH"
      'DisableThreadLibraryCalls(hInstance)
      LIBMAIN = 1
      EXIT FUNCTION
    CASE %DLL_PROCESS_DETACH
      'MSGBOX "%DLL_PROCESS_DETACH"
      EXIT FUNCTION
    CASE %DLL_THREAD_ATTACH
      'MSGBOX "%DLL_THREAD_ATTACH"
      LIBMAIN = 1
      EXIT FUNCTION
    CASE %DLL_THREAD_DETACH
      'MSGBOX "%DLL_THREAD_DETACH"
      EXIT FUNCTION

  END SELECT

  ' oops!...!
  MSGBOX "Windows Error in Libmain()"
  LIBMAIN = 0   'failure
 END FUNCTION


' This function must always be present
' ClientFeedBack contains code pointer to CallToClient in COMforDLL
' To stop Callbacks: ClientFeedback=0

FUNCTION EnableCallbacks ALIAS "EnableCallbacks" (BYVAL Feedback AS DWORD) EXPORT AS LONG
 'MSGBOX "Host EnableCallbacks is called "+STR$(Feedback)
 ClientFeedback=Feedback
END FUNCTION



'Demo functions:



'This concatenates all the arguments into a single string then returns it in "result"

FUNCTION TestFunctionReturnString ALIAS "TestFunctionReturnString" (_
 BYVAL c AS DWORD, _
 BYVAL arg AS VARIANT PTR, _
 BYVAL result AS VARIANT PTR _
 ) EXPORT AS LONG
 '
 DIM vnt(c) AS VARIANT AT arg
 DIM i AS DWORD
 DIM s AS STRING
 ' Arguments arrive in reverse order
 FOR i=1 TO c
  ' these 2 lines do the same thing
  'IF LEN(VARIANT$(@arg[c-i])) THEN s=s+VARIANT$(@arg[c-i]) ELSE s=s+STR$(VARIANT#(@arg[c-i]))' using pointer
  IF LEN(VARIANT$(vnt(c-i))) THEN s=s+VARIANT$(vnt(c-i)) ELSE s=s+STR$(VARIANT#(vnt(c-i)))' using array
  s=s+$CRLF
 NEXT
 'MSGBOX " hostlibraty result "+STR$(result)+">>"+s
 IF result THEN @result=s
END FUNCTION


FUNCTION CallMeBack ALIAS "CallMeBack" (_
 BYVAL c AS DWORD, _
 BYVAL arg AS VARIANT PTR, _
 BYVAL result AS VARIANT PTR _
 ) EXPORT AS LONG
 DIM v(3) AS VARIANT
 DIM cbk  AS DWORD
 ' MSGBOX "Hostlibrary callmeback is called "+str$(c)+STR$(ClientFeedback)
 IF (c<2)OR(ClientFeedback=0) THEN EXIT FUNCTION
 v(1)=3:v(2)=2:v(3)=1 'test data in reverse order
 v(0)=" Strings too!"
 cbk=VARIANT#(@arg[c-2]): IF cbk=0 THEN cbk=VAL(VARIANT$(@arg[c-2])): IF cbk=0 THEN EXIT FUNCTION
 ' MSGBOX "Hostlibrary callmeback is called for callback "+STR$(cbk)
 CALL DWORD ClientFeedback USING CalltoClient( cbk, VARPTR(v(0)) )
END FUNCTION
