'---------------------------------------------------------------------------------------
' Class Factory Functions
'---------------------------------------------------------------------------------------

FUNCTION classQueryInterface ( _
 BYVAL this  AS IClassFactori PTR, _
 BYREF  factoryGuid AS GUID, _
 BYVAL ppv AS DWORD PTR _
 ) AS HRESULT

    IF ((factoryGuid = IID_IUnknown)OR(factoryGuid = IID_IClassFactory)) THEN
        CALL DWORD @this.@lpVTbl.classAddRef USING classAddRef(this)
        @ppv = this
        FUNCTION = %NOERROR: EXIT FUNCTION
    END IF

    @ppv = 0
    FUNCTION = %E_NOINTERFACE
END FUNCTION


FUNCTION classAddRef ALIAS "classAddRef" ( _
 BYVAL this AS DWORD PTR _
 ) AS DWORD
 InterlockedIncrement(OutstandingObjects)
 FUNCTION=1
END FUNCTION

FUNCTION classRelease ALIAS "classRelease" ( _
 BYVAL this AS DWORD PTR _
 ) AS DWORD
 FUNCTION = InterlockedDecrement(OutstandingObjects)
END FUNCTION

FUNCTION classCreateInstance ALIAS "classCreateInstance" ( _
 BYVAL this AS IClassFactori PTR, _
 BYVAL punkOuter  AS DWORD PTR, _
 BYREF vTableGuid AS GUID, _
 BYVAL objHandle  AS DWORD PTR _
 ) AS HRESULT
    DIM hr AS HRESULT
    DIM thisobj AS Iobject PTR

    @objHandle = 0
    IF punkOuter THEN
        hr = %CLASS_E_NOAGGREGATION
    ELSE
        thisobj = GlobalAlloc(%GMEM_FIXED, SIZEOF(IObject))
        IF thisobj = 0 THEN
            hr = %E_OUTOFMEMORY
        ELSE
            'intialise object properties
            @thisobj.lpVTbl = VARPTR(MyObjectVTbl)
            @thisobj.count = 1
            @thisobj.container = VARPTR(IConnectionPointContainer_VTbl)
            @thisobj.point = VARPTR(IConnectionPoint_VTbl)
            @thisobj.feedback = 0
            DIM z AS STRING: z=UCODE$("abcd")+MKWRD$(0)
            'msgbox "Len unicode ="+str$(len(z))
            DIM p AS WORD PTR: p=STRPTR(z)
            @thisobj.tex = SysAllocStringLen(BYVAL p, LEN(z))
            CALL DWORD @thisobj.@lpVTbl.QueryInterface USING _
            QueryInterface( thisobj, vTableGuid, objHandle) _
            TO hr
            CALL DWORD MyObjectVTbl.Release USING Release(thisobj)
            IF hr = 0 THEN InterlockedIncrement(OutstandingObjects) 'win32api
        END IF
    END IF
    FUNCTION = hr
END FUNCTION

FUNCTION classLockServer ( _
 BYVAL this AS IClassFactori PTR, _
 BYVAL flock AS BOOL _
 ) AS HRESULT
    IF flock THEN
        InterlockedIncrement(LockCount)
    ELSE
        InterlockedDecrement(LockCount)
    END IF
    FUNCTION = %NOERROR
END FUNCTION
