

'-----------------------------------------------------------------------------
' Declarations
'-----------------------------------------------------------------------------

DECLARE FUNCTION CoRegisterClassObject LIB "ole32.dll" ALIAS "CoRegisterClassObject" ( _
  BYREF rclsid AS REFIID, _
  BYVAL pUnk AS IClassFactori PTR, _
  BYVAL dwClsContext AS DWORD, _
  BYVAL flags AS DWORD, _
  BYVAL lpdwRegister AS DWORD PTR _
  ) AS HRESULT

DECLARE FUNCTION CoRevokeClassObject LIB "ole32.dll" ALIAS "CoRevokeClassObject" ( _
  BYVAL nToken AS DWORD _
  ) AS hresult

DECLARE FUNCTION CoGetClassObject SDECL LIB "ole32.dll" ALIAS "CoGetClassObject" ( _
 BYREF rclsid AS REFIID, _
 BYVAL dwClsContext AS DWORD, _
 BYVAL pvReserved AS DWORD PTR, _
 BYREF riid AS REFIID, _
 BYVAL ppv AS IObject PTR _
 ) AS HRESULT

DECLARE FUNCTION LoadRegTypeLib LIB "oleaut32.dll" ALIAS "LoadRegTypeLib" ( _
 BYREF rguid AS REFIID, _
 BYVAL wVerMajor AS DWORD,_  ' c WORD
 BYVAL wVerMinor AS DWORD, _ ' c WORD
 BYVAL lc AS LCID, _
 BYVAL pptlib AS DWORD PTR _
 ) AS HRESULT

'virtual function using LIB "oleaut32.dll"
DECLARE FUNCTION GetTypeInfoOfGuid  ALIAS "GetTypeInfoOfGuid" ( _
 BYVAL typelib AS ITypeLib PTR, _
 BYREF G AS REFIID, _
 BYVAL ppTInfo AS DWORD PTR _
 ) AS HRESULT


DECLARE FUNCTION DispGetIDsOfNames LIB "oleaut32.dll" ALIAS "DispGetIDsOfNames" ( _
 BYVAL ptinfo AS DWORD PTR, _
 BYVAL rgszNames AS DWORD PTR, _
 BYVAL cnames AS WORD, _  ' unsigned int
 BYVAL rgdispid AS DISPID PTR ) _
 AS HRESULT

DECLARE FUNCTION DispInvoke LIB "OLEaut32.DLL" ALIAS "DispInvoke" ( _
 BYVAL this AS IObject PTR, _
 BYVAL ptinfo AS ITypeInfo PTR, _
 BYVAL dispidMember AS DWORD, _
 BYVAL wFlags AS   WORD, _
 BYVAL params AS DWORD PTR, _
 BYVAL result AS VARIANT PTR,_
 BYVAL pexcepinfo AS EXCEPINFO PTR, _
 BYVAL puArgErr AS DWORD PTR _
 ) AS HRESULT

DECLARE FUNCTION LoadTypeLib LIB "oleaut32.dll" ALIAS "LoadTypeLib" ( szFile AS ASCIIZ, BYVAL pptlib AS DWORD PTR ) AS LONG
  DECLARE FUNCTION RegisterTypeLib LIB "oleaut32.dll" ALIAS "RegisterTypeLib" _
  ( BYVAL ptlib AS ItypeLib PTR, szFullPath AS ASCIIZ, szHelpDir AS ASCIIZ ) AS LONG

DECLARE FUNCTION UnRegisterTypeLib LIB "oleaut32.dll" ALIAS "UnRegisterTypeLib" _
 (BYREF libID AS REFIID,BYVAL wVerMajor AS WORD, BYVAL wVerMinor AS WORD, _
 BYVAL lc AS LCID, BYVAL syskind AS DWORD) AS LONG

'---------------------------------------------------------------------------------------
' IUnknown Interface Functions
'---------------------------------------------------------------------------------------
'DECLARE FUNCTION QueryInterface ALIAS "QueryInterface" ( _
' BYVAL this AS IObject PTR, _
' BYREF vTableGuid AS REFIID , _
' BYVAL ppv AS DWORD PTR _
' ) AS DWORD

'DECLARE FUNCTION AddRef ALIAS "AddRef" ( _
' BYVAL this AS IObject PTR _
' ) AS DWORD

'DECLARE FUNCTION Release ALIAS "Release" ( _
' BYVAL this AS IObject PTR _
' ) AS DWORD

'---------------------------------------------------------------------------------------
' Additional Functions for Dispatch Interface
'---------------------------------------------------------------------------------------

'DECLARE FUNCTION GetTypeInfoCount( _
' BYVAL this AS ITypeLib PTR, _
' BYVAL pCount AS DWORD PTR _
' ) AS DWORD

'DECLARE FUNCTION loadMyTypeInfo() AS HRESULT 'helper function for GetTypeInfo below

'DECLARE FUNCTION GetTypeInfo ALIAS "GetTypeInfo" ( _
' BYVAL this AS ITypeInfo PTR, _
' BYVAL itinfo AS DWORD, _
' BYVAL lc AS LCID, _
' BYVAL pTypeInfo AS DWORD PTR _
' ) AS DWORD

' DECLARE FUNCTION GetIDsOfNames( _
' BYVAL this AS IObject PTR, _
' BYREF riid AS REFIID, _
' BYVAL rgszNames AS DWORD PTR , _
' BYVAL cNames AS DWORD, _
' BYVAL lc AS LCID, _
' BYVAL rgdispid AS DISPID PTR _
' ) AS HRESULT

DECLARE FUNCTION Invoke ( _
 BYVAL this AS IObject PTR, _
 BYVAL ndispid AS DISPID, _
 BYREF riid AS REFIID, _
 BYVAL lc AS LCID, _
 BYVAL wFlags AS WORD, _  ' c WORD length ?
 BYVAL params AS DISPPARAMS PTR, _
 BYVAL result AS VARIANT PTR,_
 BYVAL pexcepinfo AS EXCEPINFO PTR, _
 BYVAL puArgErr AS DWORD PTR _
 ) AS HRESULT


'---------------------------------------------------------------------------------------
' IClass Factory Functions
'---------------------------------------------------------------------------------------

DECLARE FUNCTION classAddRef ( _
 BYVAL this AS DWORD PTR _
 ) AS DWORD

DECLARE FUNCTION classRelease ( _
 BYVAL this AS DWORD PTR _
 ) AS DWORD

DECLARE FUNCTION classQueryInterface ( _
 BYVAL this  AS IClassFactori PTR, _
 BYREF factoryGuid AS REFIID, _
 BYVAL ppv AS DWORD PTR _
 ) AS HRESULT

DECLARE FUNCTION classCreateInstance ( _
 BYVAL this AS IClassFactori PTR, _
 BYVAL punkOuter AS DWORD PTR, _
 BYREF vTableGuid AS REFIID, _
 BYVAL objHandle AS DWORD PTR _
 ) AS HRESULT

DECLARE FUNCTION classLockServer ( _
 BYVAL this AS IClassFactori PTR, _
 BYVAL flock AS DWORD _
 ) AS HRESULT

'events

DECLARE FUNCTION QueryInterface_Connect( _
    BYVAL this AS IConnectionPointContainer PTR, _
    BYREF vTableGuid AS GUID, _
    BYVAL ppv AS DWORD PTR _
    ) AS HRESULT

DECLARE FUNCTION AddRef_Connect( _
    BYVAL this AS IConnectionPointContainer PTR _
    ) AS DWORD

DECLARE FUNCTION Release_Connect( _
    BYVAL this AS IConnectionPointContainer PTR _
    ) AS DWORD

DECLARE FUNCTION EnumConnectionPoints(_
    BYVAL this AS IConnectionPointContainer PTR, _
    BYVAL enumPoints AS DWORD PTR _
    ) AS HRESULT

DECLARE FUNCTION FindConnectionPoint( _
    BYVAL this AS DWORD PTR, _
    BYREF vTableGuid AS GUID, _
    BYVAL ppv AS DWORD PTR _
    ) AS LONG

DECLARE FUNCTION QueryInterface_Point( _
    BYVAL this AS IConnectionPoint PTR, _
    BYREF vTableGuid AS GUID, _
    BYVAL ppv AS DWORD PTR _
    ) AS HRESULT

DECLARE FUNCTION AddRef_Point( _
    BYVAL this AS IConnectionPoint PTR _
    ) AS HRESULT

DECLARE FUNCTION Release_Point( _
    BYVAL this AS IConnectionPoint PTR _
    ) AS HRESULT

DECLARE FUNCTION GetConnectionInterface( _
    BYVAL this AS IConnectionPoint PTR, _
    BYREF vTableGuid AS GUID _
    ) AS HRESULT

DECLARE FUNCTION GetConnectionPointContainer( _
    BYVAL this AS IConnectionPoint PTR, _
    BYVAL ppv AS DWORD PTR _
    ) AS HRESULT

DECLARE FUNCTION Advise( _
    BYVAL this AS IConnectionPoint PTR, _  ' sub objectof Iobject
    BYVAL obj AS IFeedback PTR, _          ' IUNKNOWN PTR
    BYVAL cookie AS DWORD PTR _            ' pointer to pointer to IFeedback
    ) AS HRESULT

DECLARE FUNCTION Unadvise( _
    BYVAL this AS IConnectionPoint PTR, _
    BYVAL cookie AS IFeedback PTR _   ' as pointer to feedback
    ) AS HRESULT

DECLARE FUNCTION EnumConnections( _
    BYVAL this AS IConnectionPoint PTR, _
    BYVAL enumConnects AS DWORD PTR _
    ) AS HRESULT

'----------------------------------------------------------------------------
' for virtual calls to an object's DLL libraries

DECLARE FUNCTION EnableHostLibraryCallbacks (_
 BYVAL pCallToClient AS DWORD _
 ) AS LONG

DECLARE FUNCTION InvokeHostLibraryProc  (_
 BYVAL c AS DWORD, _
 BYVAL arg AS VARIANT PTR, _
 BYVAL result AS VARIANT PTR _
 ) AS LONG

'-----------------------------------------------------------------------------
' this function is used by the host DLL to callback to the client

DECLARE FUNCTION CallToClient ALIAS "CallToClient" (_
    BYVAL which AS DWORD, _
    BYVAL pv AS VARIANT PTR _
    ) AS DWORD
'-----------------------------------------------------------------------------

'app methods

#INCLUDE "inc\COMserver\declMethods.inc"
