'---------------------------------------------------------------------------------------
'  methods
'---------------------------------------------------------------------------------------

FUNCTION SetString _  ' receives a BSTR
 (BYVAL this AS IObject PTR, BYVAL  str AS WORD PTR) AS HRESULT
   IF @this.tex THEN SysFreeString(@this.tex) 'win32api
   @this.tex = SysAllocString(BYVAL str) ' store a copy of the string
   IF @this.tex = 0 THEN FUNCTION= %E_OUTOFMEMORY ELSE FUNCTION=%NOERROR
END FUNCTION

FUNCTION GetString ALIAS "Application Function GetString" ( _
 BYVAL this AS IObject PTR, BYVAL buffer AS DWORD PTR) AS HRESULT
    IF buffer=0 THEN FUNCTION=%E_POINTER: EXIT FUNCTION
    @buffer=SysAllocString(BYVAL @this.tex)
    IF @buffer=0 THEN FUNCTION = %E_OUTOFMEMORY ELSE FUNCTION=%NOERROR
END FUNCTION

FUNCTION NullFun (BYVAL this AS IObject PTR) AS HRESULT
END FUNCTION

'tweaked for variant IUnknown access
FUNCTION fun ( _
 BYVAL this AS IObject PTR, _
 BYVAL prm0 AS VARIANT PTR, _
 BYVAL prm1 AS VARIANT PTR, _
 BYVAL prm2 AS VARIANT PTR, _
 BYVAL prm3 AS VARIANT PTR, _
 BYVAL prm4 AS VARIANT PTR, _
 BYVAL prm5 AS VARIANT PTR, _
 BYVAL prm6 AS VARIANT PTR, _
 BYVAL prm7 AS VARIANT PTR, _
 BYVAL prm8 AS VARIANT PTR, _
 BYVAL rslt AS VARIANT PTR _
 ) AS HRESULT
  FUNCTION = %E_NOTIMPL
END FUNCTION


FUNCTION RequestCallback(BYVAL this AS IObject PTR, BYVAL which AS DWORD) AS HRESULT
    'MSGBOX "RequestCallback"
    DIM feedback AS IFeedback PTR
    feedback = @this.feedback
    IF feedback THEN
        DIM prms AS DISPPARAMS
        DIM p AS DISPPARAMS PTR
        p=VARPTR(prms)
        FuncNumber = (which-1) MOD %MAX_CALLBACK_FUNCS + 1
        IF FuncNumber THEN
            'ZeroMemory(p, SIZEOF(DISPPARAMS))
            POKE$ p,REPEAT$(SIZEOF(DISPPARAMS),$NUL)
            'setup dispparams
            DIM v(3) AS VARIANT
            DIM va AS DWORD: va=0
            v(0)=va+1:v(1)=va+2:v(2)=va+3:v(3)=va+4 'test data
            @p.VariantArgs=VARPTR(v(0))
            @p.CountArgs=4
            CALL DWORD @feedback.@lpVTbl.Invoke _
            USING Invoke( feedback, FuncNumber, IID_NULL, 0, %DISPATCH_METHOD, p, 0, 0, 0)
        END IF
    END IF
    FUNCTION = %S_OK
END FUNCTION


FUNCTION LoadLibrary_I ( _
 BYVAL this AS IOBJECT PTR, _
 BYVAL pLibName AS WORD PTR, _  ' widestring
 BYVAL pLibr AS DWORD PTR _     ' output
 ) AS HRESULT
 @pLibr = LoadLibrary(ACODE$(PEEK$( pLibName,SysStringLen(BYVAL pLibName )*2)))
 'MSGBOX "loadlib "+HEX$(@pLibr)
 FUNCTION = %S_OK
END FUNCTION

FUNCTION GetProcAddress_I ( _
 BYVAL this AS IOBJECT PTR, _
 BYVAL Libr AS DWORD, _
 BYVAL pProcName AS WORD PTR, _
 BYVAL pProcAddr AS DWORD PTR _
 ) AS HRESULT
 IF Libr THEN @pProcAddr = GetProcAddress( Libr, ACODE$(PEEK$( pProcName,SysStringLen(BYVAL pProcName )*2)))
 FUNCTION = %S_OK
END FUNCTION

FUNCTION FreeLibrary_I ( _
 BYVAL this AS IOBJECT PTR, _
 BYVAL Libr AS DWORD, _
 BYVAL pRslt AS DWORD PTR _
 ) AS HRESULT
 @pRslt = FreeLibrary(Libr)
 FUNCTION = %S_OK
END FUNCTION

FUNCTION EnableLibraryCallbacks ( _
 BYVAL this AS IOBJECT PTR, _
 BYVAL Libr AS DWORD _
 ) AS HRESULT
 DIM p AS DWORD
 ' msgbox "EnableLibraryCallbacks "+str$(Libr)
 IF Libr=0 THEN EXIT FUNCTION
 p=GetProcAddress( Libr,"EnableCallbacks" )
 IF p THEN CALL DWORD p USING EnableHostLibraryCallbacks (CODEPTR(CallToClient))
END FUNCTION

FUNCTION DisableLibraryCallbacks ( _
 BYVAL this AS IOBJECT PTR, _
 BYVAL Libr AS DWORD _
 ) AS HRESULT
 DIM p AS DWORD
 IF Libr=0 THEN EXIT FUNCTION
 p=GetProcAddress( Libr,"EnableCallbacks" )
 IF p THEN CALL DWORD p USING EnableHostLibraryCallbacks (0)
END FUNCTION



' this function is used by the host DLL to callback to the client

FUNCTION CallToClient ALIAS "CallToClient" (_
    BYVAL which AS DWORD, _
    BYVAL pv AS VARIANT PTR _
    ) EXPORT AS DWORD
     'MSGBOX "CalltoClient"+STR$(which)+"  Ifeedback Adr "+hex$(CallClient)
    IF CallClients THEN
        FuncNumber = which
        IF FuncNumber > %MAX_CALLBACK_FUNCS THEN FuncNumber = 0
        IF FuncNumber THEN
            'setup dispparams
            DIM prms AS DISPPARAMS: POKE$ VARPTR(prms),REPEAT$(SIZEOF(DISPPARAMS),$NUL)
            prms.VariantArgs=pv: prms.CountArgs=4
            IID_NULL                      = GUID$("{00000000-0000-0000-0000-000000000000}")
            'msgbox "CallToClient is called "+str$(FuncNumber)+STR$(VARIANT#(@pv[0]))+STR$(VARIANT#(@pv[1]))
            'msgbox " "+str$(@CallClient.@lpVTbl.Callback2)
            'MSGBOX GUIDTXT$(IID_NULL)
            DIM hr AS HRESULT
            CALL DWORD @CallClients.@lpVTbl.Invoke _
            USING Invoke( CallClients, FuncNumber, IID_NULL, 0, %DISPATCH_METHOD, VARPTR(prms), 0, 0, 0) TO hr
            'MSGBOX HEX$(hr) 'any errors
        END IF
    END IF
    FUNCTION = %S_OK
END FUNCTION
